abstract class LambdaTerm {
    /**
     * Prüft ob der Term eine Normalform ist
     */
    public abstract boolean isNormal();

    /**
     * Substituiert alle Vorkommen von der Variable index mit der gegebenen Substitution
     */
    public abstract LambdaTerm substitute(int index, LambdaTerm substitution);

    /**
     * Führt einen Reduktionsschritt nach der normalen Auswertungsstrategie durch
     */
    public abstract LambdaTerm reduceNormal();

    /**
     * Führt einen Reduktionsschritt nach der applikativen Auswertungsstrategie durch
     */
    public abstract LambdaTerm reduceApplicative();

    /**
     * Reduziert einen Term zu einer Normalform mittels der normalen Auswertungsstrategie
     */
    public LambdaTerm evalNormal() {
        //TODO:
        throw new UnsupportedOperationException("");
    }

    /**
     * Reduziert einen Term zu einer Normalform mittels der applikativen Auswertungsstrategie
     */
    public LambdaTerm evalApplicative() {
        //TODO:
        throw new UnsupportedOperationException("");
    }

}
